package kawigi.tools;
import kawigi.tools.graph.*;
import javax.swing.*;

public class AccelerationGSegmentation implements GrapherSegmentation
{
	private JComboBox selectBox;
	
	public String getName()
	{
		return "Acceleration";
	}
	
	public void addSelectionWidget(GraphControlWindow window)
	{
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.add(new JLabel("Accl:"));
		if (selectBox == null)
		{
			selectBox = new JComboBox();
			selectBox.addItem("All Segments");
			selectBox.addItem("Accelerating");
			selectBox.addItem("Decelerating");
			selectBox.addItem("Constant");
			selectBox.addItem("Accl or Const");
			selectBox.addItem("Decl or Const");
			selectBox.addItem("Decl or Accl");
		}
		selectBox.addItemListener(window);
		panel.add(selectBox);
		window.getContentPane().add(panel);
	}
	
	//index == 0 means constant speed, 1 is accelerating, 2 is decelerating
	public boolean accept(int index)
	{
		if (selectBox.getSelectedItem().equals("All Segments"))
			return true;
		if (index == 0)
			return ((String)selectBox.getSelectedItem()).indexOf("Const") >= 0;
		if (index == 1)
			return ((String)selectBox.getSelectedItem()).indexOf("Acc") >= 0;
		if (index == 2)
			return ((String)selectBox.getSelectedItem()).indexOf("Dec") >= 0;
		//shouldn't reach here:
		return false;
	}
}