package kawigi.tools;
import kawigi.tools.graph.*;
import javax.swing.*;

public class DistanceGSegmentation implements GrapherSegmentation
{
	private JComboBox minBox, maxBox;
	private int divisor;
	
	public DistanceGSegmentation(int divisor)
	{
		this.divisor = divisor;
	}
	
	public String getName()
	{
		return "Distance";
	}
	
	public void addSelectionWidget(GraphControlWindow window)
	{
		System.out.println("Adding distance widgets");
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.add(new JLabel("Distance:"));
		if (minBox == null)
		{
			minBox = new JComboBox();
			maxBox = new JComboBox();
			for (int i=0; i<= 1200/divisor-1; i++)
			{
				minBox.addItem(Integer.toString(divisor*i));
				maxBox.addItem(Integer.toString(divisor*(i+1)));
			}
		}
		minBox.addItemListener(window);
		maxBox.addItemListener(window);
		panel.add(minBox);
		panel.add(new JLabel("To"));
		panel.add(maxBox);
		window.getContentPane().add(panel);
		System.out.println("Done adding distance widgets");
	}
	
	public boolean accept(int index)
	{
		return index*divisor >= Integer.parseInt(minBox.getSelectedItem().toString()) && index*divisor < Integer.parseInt(maxBox.getSelectedItem().toString());
	}
}