package kawigi.tools;
import java.io.*;
import kawigi.tools.parts.*;
import java.util.zip.*;

public class FloodGrapherFormat implements FileFormat
{
	public SegmentedData getData(File datafile) throws IOException, InvalidFileException
	{
		try
		{
			ObjectInputStream in = new ObjectInputStream(new GZIPInputStream(new FileInputStream(datafile)));
			Object stats = in.readObject();
			Segmentation[] segs = (Segmentation[])in.readObject();
			in.close();

			Scheme scheme = new Scheme();
			for (int i=0; i<segs.length; i++)
				scheme.add(segs[i].getGraphingSegmentation());
			SegmentedData data = new SegmentedData(scheme, stats);
			return data;
		}
		catch (ClassCastException e)
		{
			System.out.println(e);
			throw new InvalidFileException("File is not in FloodGrapher format");
		}
		catch (ClassNotFoundException e)
		{
			System.out.println(e);
			throw new InvalidFileException("File is not in FloodGrapher format");
		}
	}
	
	public String getFormatName()
	{
		return "FloodGrapher file format";
	}
}
