package kawigi.tools;
import java.io.*;
import kawigi.tools.*;
import java.util.zip.*;

public class FloodMini14Format implements FileFormat
{
	public SegmentedData getData(File datafile) throws IOException, InvalidFileException
	{
		try
		{
			ObjectInputStream in = new ObjectInputStream(new GZIPInputStream(new FileInputStream(datafile)));
			double[] temp = (double[])in.readObject();
			temp = (double[])in.readObject();
			int[][][][][] stats = (int[][][][][])in.readObject();
			in.close();
			double[][][][][] doublestats = new double[stats.length][stats[0].length][stats[0][0].length][stats[0][0][0].length][stats[0][0][0][0].length];
			for (int i=0; i<stats.length; i++)
				for (int j=0; j<stats[i].length; j++)
					for (int k=0; k<stats[i][j].length; k++)
						for (int l=0; l<stats[i][j][k].length; l++)
							for (int m=0; m<stats[i][j][k][l].length; m++)
								doublestats[i][j][k][l][m] = stats[i][j][k][l][m];
			Scheme scheme = new Scheme();
			scheme.add(new WallGSegmentation());
			scheme.add(new AccelerationGSegmentation());
			scheme.add(new LateralVelocityGSegmentation(3));
			scheme.add(new BFTGSegmentation(10));
			SegmentedData data = new SegmentedData(scheme, doublestats);
			return data;
		}
		catch (ClassCastException e)
		{
			throw new InvalidFileException("File is not in FloodMini 1.4 format");
		}
		catch (ClassNotFoundException e)
		{
			throw new InvalidFileException("File is not in FloodMini 1.4 format");
		}
	}
	
	public String getFormatName()
	{
		return "FloodMini 1.4 file format";
	}
}