package kawigi.tools;
import kawigi.tools.graph.*;
import javax.swing.*;
import java.util.*;

public class LateralVelocityGSegmentation implements GrapherSegmentation
{
	private double divisor;
	private JComboBox selectBox;
	
	public LateralVelocityGSegmentation(double divisor)
	{
		this.divisor = divisor;
	}
	
	public String getName()
	{
		return "Lateral Velocity";
	}
	
	public void addSelectionWidget(GraphControlWindow window)
	{
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.add(new JLabel("Lat V:"));
		if (selectBox == null)
		{
			selectBox = new JComboBox();
			selectBox.addItem("All Segments");
			for (int i=0; i-1<=8/divisor; i++)
				for (int j=i+1; j-1<=8/divisor; j++)
					selectBox.addItem(Math.min(8, i*divisor) + " to " + Math.min(8, j*divisor));
		}
		selectBox.addItemListener(window);
		panel.add(selectBox);
		window.getContentPane().add(panel);
	}
	
	public boolean accept(int index)
	{
		if (selectBox.getSelectedItem().equals("All Segments"))
			return true;
		String param = selectBox.getSelectedItem().toString();
		StringTokenizer tok = new StringTokenizer(param);
		double min = Double.parseDouble(tok.nextToken());
		tok.nextToken();	//this should be the word "to"
		double max = Double.parseDouble(tok.nextToken());
		double comp = index*divisor;
		return (comp >= min && comp <= max);
	}
}
