package kawigi.tools;
import java.util.*;
/**
 * Logically, a list of GrapherSegmentations defining how the data is set up.
 **/
public class Scheme
{
	private Vector segs;
	
	/**
	 * Creates a new Scheme
	 **/
	public Scheme()
	{
		segs = new Vector();
	}
	
	/**
	 * Returns the current size of the scheme.
	 **/
	public int size()
	{
		return segs.size();
	}
	
	/**
	 * Adds a GrapherSegmentation to the end of this Scheme.
	 **/
	public void add(GrapherSegmentation seg)
	{
		segs.add(seg);
	}
	
	/**
	 * Returns the GrapherSegmentation at the given index in the Scheme.  Used internally.
	 **/
	public GrapherSegmentation segmentAt(int index)
	{
		return (GrapherSegmentation)segs.elementAt(index);
	}
}
