package kawigi.tools;
import java.awt.geom.Point2D;

public class WaveBullet
{
	private double startx, starty, startgunheading, lastx, lasty, bulletspeed;
	private long firetime, lasttime;
	private double[] segment;
	private int direction;
	
	public WaveBullet(double startx, double starty, int direction, double bulletv, double ex, double ey, long firetime, double[] currentSegment)
	{
		this.startx = startx;
		this.starty = starty;
		startgunheading = Math.atan2(ex-startx, ey-starty);
		lastx = ex;
		lasty = ey;
		bulletspeed = bulletv;
		lasttime = this.firetime = firetime;
		this.direction = direction;
		segment = currentSegment;
	}
	
	public boolean update(double x, double y, long time)
	{
		long elapsedtime = time-lasttime;
		double dx = (x-lastx)/elapsedtime;
		double dy = (y-lasty)/elapsedtime;
		while (lasttime < time)
		{
			if (Point2D.distance(lastx, lasty, startx, starty) <= bulletspeed*(lasttime-firetime))  	//could have hit now.
			{
				double guessfactor = robocode.util.Utils.normalRelativeAngle(Math.atan2(lastx-startx, lasty-starty)-startgunheading)*direction/Math.asin(8/bulletspeed);
				segment[Math.max(0, Math.min(segment.length-1, (int)Math.round((guessfactor+1)*(segment.length/2))))]++;
				return true;
			}
			lasttime++;
			lastx+=dx;
			lasty+=dy;
		}
		return false;
	}
}

