package kawigi.tools.fs;
import java.io.*;
import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import kawigi.tools.*;

public class FloodScriptEditorPane extends FloodGrapherGUIPlugin implements ActionListener
{
	private JMenuItem openItem, saveItem, newItem, closeItem, saveAllItem, saveAsItem;
	private JButton openButton, saveButton, newButton, saveAllButton, saveAsButton, closeButton;
	private static JFileChooser fileChooser;
	private FloodGrapherGUI parent;
	private JTabbedPane tabs;
	
	public FloodScriptEditorPane(FloodGrapherGUI parent)
	{
		setLayout(new BorderLayout());
		this.parent = parent;
		newItem = new JMenuItem("New FloodScript");
		openItem = new JMenuItem("Open FloodScript...");
		saveItem = new JMenuItem("Save FloodScript");
		saveAsItem = new JMenuItem("Save FloodScript As...");
		saveAllItem = new JMenuItem("Save all FloodScripts");
		closeItem = new JMenuItem("Close FloodScript");
		openItem.addActionListener(this);
		newItem.addActionListener(this);
		saveItem.addActionListener(this);
		saveAsItem.addActionListener(this);
		saveAllItem.addActionListener(this);
		closeItem.addActionListener(this);
		parent.getJMenuBar().getMenu(0).add(openItem);
		parent.getJMenuBar().getMenu(0).add(newItem);
		parent.getJMenuBar().getMenu(0).add(saveItem);
		parent.getJMenuBar().getMenu(0).add(closeItem);
		parent.getJMenuBar().getMenu(0).addSeparator();
		tabs = new JTabbedPane(JTabbedPane.BOTTOM);
		tabs.addTab("Untitled", new FloodScriptEditor(tabs));
		add(tabs);
		
		JToolBar toolbar = new JToolBar();
		openButton = new JButton(new ImageIcon("kawigi" + File.separator + "resource" + File.separator + "general" + File.separator + "Open24.gif"));
		saveButton = new JButton(new ImageIcon("kawigi" + File.separator + "resource" + File.separator + "general" + File.separator + "Save24.gif"));
		newButton = new JButton(new ImageIcon("kawigi" + File.separator + "resource" + File.separator + "general" + File.separator + "New24.gif"));
		saveAllButton = new JButton(new ImageIcon("kawigi" + File.separator + "resource" + File.separator + "general" + File.separator + "SaveAll24.gif"));
		saveAsButton = new JButton(new ImageIcon("kawigi" + File.separator + "resource" + File.separator + "general" + File.separator + "SaveAs24.gif"));
		closeButton = new JButton(new ImageIcon("kawigi" + File.separator + "resource" + File.separator + "general" + File.separator + "Remove24.gif"));
		toolbar.add(newButton);
		toolbar.add(openButton);
		toolbar.add(saveButton);
		toolbar.add(saveAsButton);
		toolbar.add(saveAllButton);
		toolbar.add(closeButton);
		add(toolbar, BorderLayout.NORTH);
		openButton.addActionListener(this);
		newButton.addActionListener(this);
		saveButton.addActionListener(this);
		saveAsButton.addActionListener(this);
		saveAllButton.addActionListener(this);
		closeButton.addActionListener(this);
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() instanceof JMenuItem)
			parent.getTabbedPane().setSelectedComponent(this);
		if (e.getSource() == newItem || e.getSource() == newButton)
		{
			FloodScriptEditor currentTab = new FloodScriptEditor(tabs);
			tabs.addTab("Untitled", currentTab);
			tabs.setSelectedComponent(currentTab);
		}
		if (e.getSource() == openItem || e.getSource() == openButton)
		{
			if (fileChooser == null)
				fileChooser = new JFileChooser();
			if (fileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
			{
				FloodScriptEditor currentTab = new FloodScriptEditor(tabs);
				tabs.addTab("Untitled", currentTab);
				currentTab.open(fileChooser.getSelectedFile());
				tabs.setSelectedComponent(currentTab);
			}
		}
		else if (e.getSource() == saveItem || e.getSource() == saveButton || e.getSource() == saveAsItem || e.getSource() == saveAsButton)
		{
			if (fileChooser == null)
				fileChooser = new JFileChooser();
			((FloodScriptEditor)tabs.getSelectedComponent()).save(fileChooser, (e.getSource() == saveAsItem || e.getSource() == saveAsButton));
		}
		else if (e.getSource() == saveAllItem || e.getSource() == saveAllButton)
		{
			if (fileChooser == null)
				fileChooser = new JFileChooser();
			for (int i=0; i<tabs.getComponents().length; i++)
				((FloodScriptEditor)tabs.getComponentAt(i)).save(fileChooser, false);
		}
		else if (e.getSource() == closeItem || e.getSource() == closeButton)
		{
			if (((FloodScriptEditor)tabs.getSelectedComponent()).close())
				tabs.remove(tabs.getSelectedComponent());
			if (tabs.getTabCount() == 0)
				tabs.addTab("Untitled", new FloodScriptEditor(tabs));
		}
	}
	
	public String getName()
	{
		return "FS Editor";
	}
	
	public String getFloodScriptCommand()
	{
		return 	  "#This is the FloodScript editor:\n"
			+ "plugin=kawigi.tools.fs.FloodScriptEditorPane(this)\n";
	}
}
