package kawigi.tools.graph;
import kawigi.tools.*;
import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class FloodGrapherPane extends FloodGrapherGUIPlugin implements ActionListener
{
	private GraphDisplayer graph;
	private JDesktopPane container;
	private JSplitPane split;
	private JMenuItem newItem;
	private FloodGrapherGUI parent;
	
	public FloodGrapherPane(FloodGrapherGUI parent)
	{
		this.parent = parent;
		setLayout(new GridLayout(1, 1));
		newItem = new JMenuItem("Open Graph...");
		parent.getJMenuBar().getMenu(0).add(newItem);
		parent.getJMenuBar().getMenu(0).addSeparator();
		newItem.addActionListener(this);
		
		graph = new GraphDisplayer();
		container = new JDesktopPane();
		container.setPreferredSize(new Dimension(300, 400));
		split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, graph, container);
		add(split);
	}
	
	public void initialize()
	{
		split.setDividerLocation(((Number)parent.getFloodScriptParser().getObject("divider", new Integer(split.getDividerLocation()))).intValue());
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == newItem)
		{
			parent.getTabbedPane().setSelectedComponent(this);
			Vector formatList = parent.getFloodScriptParser().getObjectList("fileFormat");
			FileFormat[] formats = new FileFormat[formatList.size()];
			formatList.toArray(formats);
			new NewGraphWindow(container, graph, parent, formats, new File((String)parent.getFloodScriptParser().getObject("defaultDirectory", ".")));
		}
	}
	
	public String getName()
	{
		return "Grapher";
	}
	
	public String getFloodScriptCommand()
	{
		return	  "# I don't know why you wouldn't want to have this show up:\n"
			+ "plugin=kawigi.tools.graph.FloodGrapherPane(this)\n"
			+ "# You can also set where the divider goes between the graph and the desktop\n"
			+ "divider=[i" + split.getDividerLocation() + "]\n";
	}
}
