package kawigi.tools.graph;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;

public class GraphColorSelector extends JPanel implements MouseListener, MouseMotionListener
{
	private float currentValue;
	private static int count = 0;
	private Vector als;
	
	public GraphColorSelector()
	{
		setPreferredSize(new Dimension(200, 25));
		als = new Vector();
		currentValue = ((float)count/6)%1;
		count++;
		addMouseListener(this);
		addMouseMotionListener(this);
	}
	
	public void addActionListener(ActionListener al)
	{
		als.add(al);
	}
	
	public Color getSelectedColor()
	{
		return Color.getHSBColor(currentValue, 1, 1);
	}
	
	public void paint(Graphics g)
	{
		super.paint(g);
		g.setColor(Color.getHSBColor(currentValue, 1, 1));
		g.fillRect(170, 5, 20, 15);
		for (int i=0; i<150; i++)
		{
			g.setColor(Color.getHSBColor((float)i/150, 1, 1));
			g.drawLine(10+i, 5, 10+i, 20);
		}
		g.setColor(Color.black);
		g.drawRect(10, 5, 150, 15);
		g.drawRect(170, 5, 20, 15);
		for (int i=(int)(currentValue*150)-1; i<=(int)(currentValue*150)+1; i++)
			g.drawLine(10+i, 2, 10+i, 23);
	}
	
	public void mousePressed(MouseEvent e)
	{
		currentValue = Math.min(1, Math.max(0, (float)(e.getX()-10)/150));
		repaint();
	}
	
	public void mouseReleased(MouseEvent e)
	{
		currentValue = Math.min(1, Math.max(0, (float)(e.getX()-10)/150));
		for (int i=0; i<als.size(); i++)
			((ActionListener)als.elementAt(i)).actionPerformed(new ActionEvent(this, 0, "Change color"));
		repaint();
	}
	
	public void mouseDragged(MouseEvent e)
	{
		currentValue = Math.min(1, Math.max(0, (float)(e.getX()-10)/150));
		repaint();
	}
	
	public void mouseClicked(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	public void mouseMoved(MouseEvent e){}
}