package kawigi.tools.graph;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.text.*;

public class GraphDisplayer extends JPanel
{
	private HashMap graphs;
	private NumberFormat percent;
	
	public GraphDisplayer()
	{
		setBackground(Color.white);
		setPreferredSize(new Dimension(400, 400));
		graphs = new HashMap();
		percent = NumberFormat.getPercentInstance();
		percent.setMaximumFractionDigits(2);
	}
	
	public void addGraph(GraphData graph, GraphControlWindow source)
	{
		graphs.put(source, graph);
		repaint();
	}
	
	public void removeGraph(GraphControlWindow source)
	{
		graphs.remove(source);
		repaint();
	}
	
	public void paint(Graphics g)
	{
		super.paint(g);
		g.setColor(Color.gray);
		g.drawRect(20, 20, getSize().width-40, getSize().height-40);
		g.drawLine(getSize().width/2, 20, getSize().width/2, getSize().height-20);
		g.drawLine(getSize().width/4, 20, getSize().width/4, getSize().height-20);
		g.drawLine(3*getSize().width/4, 20, 3*getSize().width/4, getSize().height-20);
		g.drawRect(20, 20, 70, 20*graphs.size());
		g.setColor(Color.black);
		g.setFont(new Font("Courier", Font.PLAIN, 14));
		g.drawString("-1.0", 0, getSize().height-5);
		g.drawString("-0.5", getSize().width/4-20, getSize().height-5);
		g.drawString("0.0", getSize().width/2-15, getSize().height-5);
		g.drawString("+0.5", 3*getSize().width/4-20, getSize().height-5);
		g.drawString("+1.0", getSize().width-40, getSize().height-5);
		int count = 0;
		Iterator it = graphs.values().iterator();
		while (it.hasNext())
		{
			GraphData graph = (GraphData)it.next();
			g.setColor(graph.getColor());
			double[] data = graph.getData();
			double max = Double.NEGATIVE_INFINITY;
			for (int i=0; i<data.length; i++)
				max = Math.max(max, data[i]);
			for (int i=1; i<data.length; i++)
				g.drawLine(20+i*(getSize().width-40)/(data.length-1), getSize().height-(int)(20+data[i]*(getSize().height-40)/max), 20+(i-1)*(getSize().width-40)/(data.length-1), getSize().height-(int)(20+data[i-1]*(getSize().height-40)/max));
			g.drawString(percent.format(graph.getPercentAtHighest()), 25, 35+count*20);
			count++;
		}
	}
}