package kawigi.tools.help;
import javax.swing.*;
import java.io.*;
import javax.swing.plaf.basic.BasicHTML;
import javax.swing.text.*;
import javax.swing.text.html.*;
import java.awt.*;
import javax.swing.event.*;

public class HTMLViewer extends JTextPane
{
	public HTMLViewer()
	{
		setBackground(Color.white);
		setEditable(false);
	}
	
	public String goToPage(File file)
	{
		String result = "", stackTrace = "";
		StackTraceElement[] stackTraceParts = null;
		HTMLEditorKit htmlKit = new HTMLEditorKit();
		setEditorKit(htmlKit);
		try
		{
			Reader inFile = new FileReader(file);
			htmlKit.read(inFile, getDocument(),0);
		}
		catch (FileNotFoundException e)
		{
			result = "Help File not found: " + file;
			stackTrace = e.getMessage() + "\n";
			stackTraceParts = e.getStackTrace();
		}
		catch (IOException e)
		{
			result = "I/O Exception";
			stackTrace = e.getMessage() + "\n";
			stackTraceParts = e.getStackTrace();
		}
		catch (BadLocationException e)
		{
			result = "Bad location (?)";
			stackTrace = e.getMessage() + "\n";
			stackTraceParts = e.getStackTrace();
		}
		
		if (stackTraceParts != null)
		{
			for (int i=0; i<stackTraceParts.length; i++)
				stackTrace += "\t" + stackTraceParts[i] + "\n";
		}
		
		if (result.length() > 0)
		{
			try
			{
				StringReader errorFile = new StringReader("<html>\n<head>\n<title>Page not found</title>\n</head>\n<body>\n<h1>Page not Found</h1>\n<p>An exception occured while trying to access this page.</p>\n<p>Description of problem:</p>\n<pre>" + stackTrace + "</pre>\n</body>\n</html>");
				htmlKit.read(errorFile, getDocument(),0);
			}
			catch (IOException e)
			{
				result += ", unresolved I/O Exception";
			}
			catch (BadLocationException e)
			{
				result += ", unresolved Bad Location Exception";
			}
		}
		
		return result;
	}
}
