package kawigi.tools.parts;
import robocode.*;
import kawigi.tools.*;

public class BulletFlightTimeSegmentation implements Segmentation, java.io.Serializable
{
	private int segmentSize;
	
	public BulletFlightTimeSegmentation(int segmentSize)
	{
		this.segmentSize = segmentSize;
	}
	
	public int numSegments()
	{
		return (int)Math.ceil(1200/11.0/segmentSize);
	}
	
	public GrapherSegmentation getGraphingSegmentation()
	{
		return new BFTGSegmentation(segmentSize);
	}
	
	public int getSegmentIndex(ScannedRobotEvent e, AdvancedRobot ar, PowerManagement em)
	{
		return (int)(e.getDistance()/(20-em.getPower(e, ar)*3)/segmentSize);
	}
}
