package kawigi.tools.parts;
import robocode.*;
import kawigi.tools.*;

public class DistanceSegmentation implements Segmentation, java.io.Serializable
{
	private int segmentSize;
	
	public DistanceSegmentation(int segmentSize)
	{
		this.segmentSize = segmentSize;
	}
	
	public int numSegments()
	{
		return (int)Math.ceil(1200/segmentSize);
	}
	
	public GrapherSegmentation getGraphingSegmentation()
	{
		return new DistanceGSegmentation(segmentSize);
	}
	
	public int getSegmentIndex(ScannedRobotEvent e, AdvancedRobot ar, PowerManagement em)
	{
		return (int)(e.getDistance()/segmentSize);
	}
}
