package kawigi.tools.parts;
import kawigi.tools.*;
import robocode.*;

public class LateralVelocitySegmentation implements Segmentation, java.io.Serializable
{
	private double segmentSize;
	
	public LateralVelocitySegmentation(double segmentSize)
	{
		this.segmentSize = segmentSize;
	}
	
	public int numSegments()
	{
		return (int)Math.ceil(8/segmentSize);
	}
	
	public GrapherSegmentation getGraphingSegmentation()
	{
		return new LateralVelocityGSegmentation(segmentSize);
	}
	
	public int getSegmentIndex(ScannedRobotEvent e, AdvancedRobot ar, PowerManagement em)
	{
		return (int)Math.abs(Math.sin(e.getHeadingRadians()-ar.getHeadingRadians()-e.getBearingRadians())*e.getVelocity()/segmentSize);
	}
}
