package kawigi.tools.parts;
import robocode.*;

/**
 * This interface should be implemented to extend the movement of the FloodGrapher robot
 **/
public interface Movement
{
	/**
	 * Called for every event handler in the robot.  Use instanceof to find out what kind of
	 * event it is and handle the ones you care about.
	 **/
	public void onEvent(Event e, AdvancedRobot ar);
	
	/**
	 * Called in each iteration of the run loop (each tick)
	 **/
	public void run(AdvancedRobot ar);
}
