package kawigi.tools.parts;
import kawigi.tools.*;
import robocode.*;

/**
 * Interface to be implemented to extend FloodGrapher's targeting algorithm.  Configure in robot.ini
 * in FloodGrapher's data directory.
 **/
public interface Segmentation
{
	/**
	 * Returns the number of segments the data is divided into along this axis.
	 **/
	public int numSegments();
	
	/**
	 * Returns the corresponding GrapherSegmentation to be used by the FloodGrapher application.
	 **/
	public GrapherSegmentation getGraphingSegmentation();
	
	/**
	 * Returns the index that should be used in the given condition.
	 **/
	public int getSegmentIndex(ScannedRobotEvent e, AdvancedRobot ar, PowerManagement em);
}
