package kawigi.tools.parts;
import robocode.*;

public class StaticDistancing implements DistancingAlgorithm
{
	private double minDistance, maxDistance, currentDistance;

	public StaticDistancing(double min, double max)
	{
		minDistance = min;
		maxDistance = max;
	}
	
	public int getDistanceDirection()
	{
		if (currentDistance < minDistance)
			return 1;
		else if (currentDistance > maxDistance)
			return -1;
		else
			return 0;
	}
	
	public void onEvent(Event e)
	{
		if (e instanceof ScannedRobotEvent)
		{
			currentDistance = ((ScannedRobotEvent)e).getDistance();
		}
	}
}
