package kawigi.tools.parts;
import robocode.*;
import kawigi.tools.*;
import java.awt.geom.*;

public class WallSegmentation implements Segmentation, java.io.Serializable
{
	public int numSegments()
	{
		return 2;
	}
	
	public GrapherSegmentation getGraphingSegmentation()
	{
		return new WallGSegmentation();
	}
	
	public int getSegmentIndex(ScannedRobotEvent e, AdvancedRobot ar, PowerManagement em)
	{
		Rectangle2D fieldRect = new Rectangle2D.Double(18, 18, ar.getBattleFieldWidth()-36, ar.getBattleFieldHeight()-36);
		double ex = ar.getX()+Math.sin(ar.getHeadingRadians()+e.getBearingRadians())*e.getDistance();
		double ey = ar.getY()+Math.cos(ar.getHeadingRadians()+e.getBearingRadians())*e.getDistance();
		double direction = (e.getVelocity() < 0) ? -80 : 80;
		double projectedx = ex+Math.sin(e.getHeadingRadians())*direction;
		double projectedy = ey+Math.cos(e.getHeadingRadians())*direction;
		if (fieldRect.contains(projectedx, projectedy))
			return 0;
		else
			return 1;
	}
}
